# coding: utf-8

"""
    Zadara VPSA Storage Array REST API

     # Overview  This document outlines the methods available for administrating your Zadara Storage VPSA&#8482;. The Zadara Storage Array REST API   supports form-encoded, JSON, and XML requests, and can return either JSON or XML responses.  ## Usage  The majority of the APIs available require authentication which requires an API token to use. You can retrieve this token through the   Users section of your VPSA, or through the API using the \"Return a user's access key\" API in the Users Section below.  ## Authentication Methods  The authentication token can be passed either through the access_key parameter inside of the body of the REST API request, or   through the X-Access-Key header.  ## Timeouts  By default, all operations that don't complete within five seconds will return a message informing you that the action may take some  time to complete. When using the API, this can cause some actions, such as large volume creation, to be undesirably asynchronous.  You can specify your own timeout with the timeout parameter, in seconds, and a timeout value of -1 specifies an infinite timeout.  ## Specific Fields For Product  Some of the fields/actions used in the API should be used only for a specific product. The following tags are used to mark which   product responds to the fields/actions  VPSA Flash Array  VPSA Storage Array - Hybrid VPSA  ## Questions  If you have any questions or need support involving the REST API, please contact for assistance.   # noqa: E501

    OpenAPI spec version: 23.09
    Contact: support@zadarastorage.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from Vpsa.api_client import ApiClient


class ConsistencyGroupsApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def cancel_suspend_for_snapshot_set(self, cancel_suspend_for_snapshot_set, **kwargs):  # noqa: E501
        """cancel_suspend_for_snapshot_set  # noqa: E501

        Cancel suspend for a snapshot set.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.cancel_suspend_for_snapshot_set(cancel_suspend_for_snapshot_set, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param CancelSuspendForSnapshotSet cancel_suspend_for_snapshot_set: (required)
        :return: InlineResponse2005
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.cancel_suspend_for_snapshot_set_with_http_info(cancel_suspend_for_snapshot_set, **kwargs)  # noqa: E501
        else:
            (data) = self.cancel_suspend_for_snapshot_set_with_http_info(cancel_suspend_for_snapshot_set, **kwargs)  # noqa: E501
            return data

    def cancel_suspend_for_snapshot_set_with_http_info(self, cancel_suspend_for_snapshot_set, **kwargs):  # noqa: E501
        """cancel_suspend_for_snapshot_set  # noqa: E501

        Cancel suspend for a snapshot set.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.cancel_suspend_for_snapshot_set_with_http_info(cancel_suspend_for_snapshot_set, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param CancelSuspendForSnapshotSet cancel_suspend_for_snapshot_set: (required)
        :return: InlineResponse2005
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['cancel_suspend_for_snapshot_set']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method cancel_suspend_for_snapshot_set" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'cancel_suspend_for_snapshot_set' is set
        if self.api_client.client_side_validation and ('cancel_suspend_for_snapshot_set' not in params or
                                                       params['cancel_suspend_for_snapshot_set'] is None):  # noqa: E501
            raise ValueError("Missing the required parameter `cancel_suspend_for_snapshot_set` when calling `cancel_suspend_for_snapshot_set`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'cancel_suspend_for_snapshot_set' in params:
            body_params = params['cancel_suspend_for_snapshot_set']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json', 'application/xml'])  # noqa: E501

        # Authentication setting
        auth_settings = ['api_key']  # noqa: E501

        return self.api_client.call_api(
            '/consistency_groups/cancel_suspend_for_snapshot_set.json', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse2005',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def clone_snapshot_set(self, clone_snapshot_set, **kwargs):  # noqa: E501
        """clone_snapshot_set  # noqa: E501

        Clone a snapshot set.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.clone_snapshot_set(clone_snapshot_set, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param CloneSnapshotSet clone_snapshot_set: (required)
        :return: InlineResponse2002
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.clone_snapshot_set_with_http_info(clone_snapshot_set, **kwargs)  # noqa: E501
        else:
            (data) = self.clone_snapshot_set_with_http_info(clone_snapshot_set, **kwargs)  # noqa: E501
            return data

    def clone_snapshot_set_with_http_info(self, clone_snapshot_set, **kwargs):  # noqa: E501
        """clone_snapshot_set  # noqa: E501

        Clone a snapshot set.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.clone_snapshot_set_with_http_info(clone_snapshot_set, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param CloneSnapshotSet clone_snapshot_set: (required)
        :return: InlineResponse2002
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['clone_snapshot_set']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method clone_snapshot_set" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'clone_snapshot_set' is set
        if self.api_client.client_side_validation and ('clone_snapshot_set' not in params or
                                                       params['clone_snapshot_set'] is None):  # noqa: E501
            raise ValueError("Missing the required parameter `clone_snapshot_set` when calling `clone_snapshot_set`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'clone_snapshot_set' in params:
            body_params = params['clone_snapshot_set']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json', 'application/xml'])  # noqa: E501

        # Authentication setting
        auth_settings = ['api_key']  # noqa: E501

        return self.api_client.call_api(
            '/consistency_groups/clone_snapshot_set.json', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse2002',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def create_snapshot_set_and_resume(self, create_snapshot_set_and_resume, **kwargs):  # noqa: E501
        """create_snapshot_set_and_resume  # noqa: E501

        Create a snapshot set and resumes.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.create_snapshot_set_and_resume(create_snapshot_set_and_resume, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param CreateSnapshotSetAndResume create_snapshot_set_and_resume: (required)
        :return: InlineResponse2001
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.create_snapshot_set_and_resume_with_http_info(create_snapshot_set_and_resume, **kwargs)  # noqa: E501
        else:
            (data) = self.create_snapshot_set_and_resume_with_http_info(create_snapshot_set_and_resume, **kwargs)  # noqa: E501
            return data

    def create_snapshot_set_and_resume_with_http_info(self, create_snapshot_set_and_resume, **kwargs):  # noqa: E501
        """create_snapshot_set_and_resume  # noqa: E501

        Create a snapshot set and resumes.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.create_snapshot_set_and_resume_with_http_info(create_snapshot_set_and_resume, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param CreateSnapshotSetAndResume create_snapshot_set_and_resume: (required)
        :return: InlineResponse2001
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['create_snapshot_set_and_resume']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method create_snapshot_set_and_resume" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'create_snapshot_set_and_resume' is set
        if self.api_client.client_side_validation and ('create_snapshot_set_and_resume' not in params or
                                                       params['create_snapshot_set_and_resume'] is None):  # noqa: E501
            raise ValueError("Missing the required parameter `create_snapshot_set_and_resume` when calling `create_snapshot_set_and_resume`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'create_snapshot_set_and_resume' in params:
            body_params = params['create_snapshot_set_and_resume']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json', 'application/xml'])  # noqa: E501

        # Authentication setting
        auth_settings = ['api_key']  # noqa: E501

        return self.api_client.call_api(
            '/consistency_groups/create_snapshot_set_and_resume.json', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse2001',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def delete_clone_snapshot_set(self, delete_clone_snapshot_set, **kwargs):  # noqa: E501
        """delete_clone_snapshot_set  # noqa: E501

        Delete a clone of a snapshot set.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_clone_snapshot_set(delete_clone_snapshot_set, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param DeleteCloneSnapshotSet delete_clone_snapshot_set: (required)
        :return: InlineResponse2003
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.delete_clone_snapshot_set_with_http_info(delete_clone_snapshot_set, **kwargs)  # noqa: E501
        else:
            (data) = self.delete_clone_snapshot_set_with_http_info(delete_clone_snapshot_set, **kwargs)  # noqa: E501
            return data

    def delete_clone_snapshot_set_with_http_info(self, delete_clone_snapshot_set, **kwargs):  # noqa: E501
        """delete_clone_snapshot_set  # noqa: E501

        Delete a clone of a snapshot set.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_clone_snapshot_set_with_http_info(delete_clone_snapshot_set, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param DeleteCloneSnapshotSet delete_clone_snapshot_set: (required)
        :return: InlineResponse2003
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['delete_clone_snapshot_set']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method delete_clone_snapshot_set" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'delete_clone_snapshot_set' is set
        if self.api_client.client_side_validation and ('delete_clone_snapshot_set' not in params or
                                                       params['delete_clone_snapshot_set'] is None):  # noqa: E501
            raise ValueError("Missing the required parameter `delete_clone_snapshot_set` when calling `delete_clone_snapshot_set`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'delete_clone_snapshot_set' in params:
            body_params = params['delete_clone_snapshot_set']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json', 'application/xml'])  # noqa: E501

        # Authentication setting
        auth_settings = ['api_key']  # noqa: E501

        return self.api_client.call_api(
            '/consistency_groups/delete_clone_of_snapshot_set.json', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse2003',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def delete_snapshot_set(self, delete_snapshot_set, **kwargs):  # noqa: E501
        """delete_snapshot_set  # noqa: E501

        Delete a snapshot set.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_snapshot_set(delete_snapshot_set, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param DeleteSnapshotSet delete_snapshot_set: (required)
        :return: InlineResponse2004
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.delete_snapshot_set_with_http_info(delete_snapshot_set, **kwargs)  # noqa: E501
        else:
            (data) = self.delete_snapshot_set_with_http_info(delete_snapshot_set, **kwargs)  # noqa: E501
            return data

    def delete_snapshot_set_with_http_info(self, delete_snapshot_set, **kwargs):  # noqa: E501
        """delete_snapshot_set  # noqa: E501

        Delete a snapshot set.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_snapshot_set_with_http_info(delete_snapshot_set, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param DeleteSnapshotSet delete_snapshot_set: (required)
        :return: InlineResponse2004
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['delete_snapshot_set']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method delete_snapshot_set" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'delete_snapshot_set' is set
        if self.api_client.client_side_validation and ('delete_snapshot_set' not in params or
                                                       params['delete_snapshot_set'] is None):  # noqa: E501
            raise ValueError("Missing the required parameter `delete_snapshot_set` when calling `delete_snapshot_set`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'delete_snapshot_set' in params:
            body_params = params['delete_snapshot_set']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json', 'application/xml'])  # noqa: E501

        # Authentication setting
        auth_settings = ['api_key']  # noqa: E501

        return self.api_client.call_api(
            '/consistency_groups/delete_snapshot_set.json', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse2004',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def suspend_cgs_for_snapshot_set(self, suspend_cgs_for_snapshot_set, **kwargs):  # noqa: E501
        """suspend_cgs_for_snapshot_set  # noqa: E501

        Suspend consistency groups for a snapshot set.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.suspend_cgs_for_snapshot_set(suspend_cgs_for_snapshot_set, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param SuspendCgsForSnapshotSet suspend_cgs_for_snapshot_set: (required)
        :return: InlineResponse200
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.suspend_cgs_for_snapshot_set_with_http_info(suspend_cgs_for_snapshot_set, **kwargs)  # noqa: E501
        else:
            (data) = self.suspend_cgs_for_snapshot_set_with_http_info(suspend_cgs_for_snapshot_set, **kwargs)  # noqa: E501
            return data

    def suspend_cgs_for_snapshot_set_with_http_info(self, suspend_cgs_for_snapshot_set, **kwargs):  # noqa: E501
        """suspend_cgs_for_snapshot_set  # noqa: E501

        Suspend consistency groups for a snapshot set.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.suspend_cgs_for_snapshot_set_with_http_info(suspend_cgs_for_snapshot_set, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param SuspendCgsForSnapshotSet suspend_cgs_for_snapshot_set: (required)
        :return: InlineResponse200
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['suspend_cgs_for_snapshot_set']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method suspend_cgs_for_snapshot_set" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'suspend_cgs_for_snapshot_set' is set
        if self.api_client.client_side_validation and ('suspend_cgs_for_snapshot_set' not in params or
                                                       params['suspend_cgs_for_snapshot_set'] is None):  # noqa: E501
            raise ValueError("Missing the required parameter `suspend_cgs_for_snapshot_set` when calling `suspend_cgs_for_snapshot_set`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'suspend_cgs_for_snapshot_set' in params:
            body_params = params['suspend_cgs_for_snapshot_set']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json', 'application/xml'])  # noqa: E501

        # Authentication setting
        auth_settings = ['api_key']  # noqa: E501

        return self.api_client.call_api(
            '/consistency_groups/suspend_cgs_for_snapshot_set.json', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse200',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
