# coding: utf-8

"""
    Zadara VPSA Object Storage REST API

    # Overview  This document outlines the methods available for administrating your VPSA&#174; Object Storage. The API supports form-encoded, JSON, and XML requests, and can return either JSON or XML responses.  ## Usage  The majority of the APIs available require authentication which requires an API token to use. You can retrieve this token through the Users section of your VPSA, or through the API using the \"Return a user's access key\" API in the Users Section below.  ## Authentication Methods  The authentication token can be passed either through the access_key parameter inside of the body of the REST API request, or through the X-Access-Key header. Alternately, you can use the username and password parameters for authentication, but we do not recommend this method for anything other than possibly retrieving an API key.  By default , all operations are allowed only to VPSA Object Storage admin. Some actions are allowed by an account admin and they will be marked on the action's header  ## Timeouts  By default, all operations that don't complete within five seconds will return a message informing you that the action may take some time to complete. When using the API, this can cause some actions, such as adding drives to storage policy, to be undesirably asynchronous. You can specify your own timeout with the timeout parameter, in seconds, and a timeout value of -1 specifies an infinite timeout.  ## Metering API  Metering information can be retrieved using the VPSA Object Storage API for the following components:  - Accounts - Users - Drives - Virtual Controllers - Load Balancer Groups - Storage Policies  Metering information returned by the API is subject to the following constraints:  - 10 seconds interval - 1 hour range - 1 minute interval - 1 day range - 1 hour interval - 30 days range  Values outside the accepted range will be returned as 0.  ## Questions  If you have any questions or need support involving the REST API, please contact for assistance.   # noqa: E501

    OpenAPI spec version: 23.09
    Contact: support@zadarastorage.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from Zios.configuration import Configuration


class CreateObjectStorageDestination(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'name': 'str',
        'type': 'str',
        'endpoint': 'str',
        'endpoint_url': 'str',
        'region': 'str',
        'username': 'str',
        'password': 'str',
        'connect_via': 'str'
    }

    attribute_map = {
        'name': 'name',
        'type': 'type',
        'endpoint': 'endpoint',
        'endpoint_url': 'endpoint_url',
        'region': 'region',
        'username': 'username',
        'password': 'password',
        'connect_via': 'connectVia'
    }

    def __init__(self, name=None, type=None, endpoint=None, endpoint_url=None, region=None, username=None, password=None, connect_via=None, _configuration=None):  # noqa: E501
        """CreateObjectStorageDestination - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._name = None
        self._type = None
        self._endpoint = None
        self._endpoint_url = None
        self._region = None
        self._username = None
        self._password = None
        self._connect_via = None
        self.discriminator = None

        self.name = name
        self.type = type
        self.endpoint = endpoint
        self.endpoint_url = endpoint_url
        self.region = region
        self.username = username
        self.password = password
        self.connect_via = connect_via

    @property
    def name(self):
        """Gets the name of this CreateObjectStorageDestination.  # noqa: E501

        Display Name for Remote Object Storage Endpoint  # noqa: E501

        :return: The name of this CreateObjectStorageDestination.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this CreateObjectStorageDestination.

        Display Name for Remote Object Storage Endpoint  # noqa: E501

        :param name: The name of this CreateObjectStorageDestination.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def type(self):
        """Gets the type of this CreateObjectStorageDestination.  # noqa: E501

        Type for Remote Object Storage Endpoint  # noqa: E501

        :return: The type of this CreateObjectStorageDestination.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this CreateObjectStorageDestination.

        Type for Remote Object Storage Endpoint  # noqa: E501

        :param type: The type of this CreateObjectStorageDestination.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and type is None:
            raise ValueError("Invalid value for `type`, must not be `None`")  # noqa: E501
        allowed_values = ["AWS_S3", "ZIOS_S3"]  # noqa: E501
        if (self._configuration.client_side_validation and
                type not in allowed_values):
            raise ValueError(
                "Invalid value for `type` ({0}), must be one of {1}"  # noqa: E501
                .format(type, allowed_values)
            )

        self._type = type

    @property
    def endpoint(self):
        """Gets the endpoint of this CreateObjectStorageDestination.  # noqa: E501

        Endpoint for AWS S3 destination type  # noqa: E501

        :return: The endpoint of this CreateObjectStorageDestination.  # noqa: E501
        :rtype: str
        """
        return self._endpoint

    @endpoint.setter
    def endpoint(self, endpoint):
        """Sets the endpoint of this CreateObjectStorageDestination.

        Endpoint for AWS S3 destination type  # noqa: E501

        :param endpoint: The endpoint of this CreateObjectStorageDestination.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and endpoint is None:
            raise ValueError("Invalid value for `endpoint`, must not be `None`")  # noqa: E501

        self._endpoint = endpoint

    @property
    def endpoint_url(self):
        """Gets the endpoint_url of this CreateObjectStorageDestination.  # noqa: E501

        Endpoint URL for VPSA Object Storage S3 destination type  # noqa: E501

        :return: The endpoint_url of this CreateObjectStorageDestination.  # noqa: E501
        :rtype: str
        """
        return self._endpoint_url

    @endpoint_url.setter
    def endpoint_url(self, endpoint_url):
        """Sets the endpoint_url of this CreateObjectStorageDestination.

        Endpoint URL for VPSA Object Storage S3 destination type  # noqa: E501

        :param endpoint_url: The endpoint_url of this CreateObjectStorageDestination.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and endpoint_url is None:
            raise ValueError("Invalid value for `endpoint_url`, must not be `None`")  # noqa: E501

        self._endpoint_url = endpoint_url

    @property
    def region(self):
        """Gets the region of this CreateObjectStorageDestination.  # noqa: E501

        Region for VPSA Object Storage S3 destination type  # noqa: E501

        :return: The region of this CreateObjectStorageDestination.  # noqa: E501
        :rtype: str
        """
        return self._region

    @region.setter
    def region(self, region):
        """Sets the region of this CreateObjectStorageDestination.

        Region for VPSA Object Storage S3 destination type  # noqa: E501

        :param region: The region of this CreateObjectStorageDestination.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and region is None:
            raise ValueError("Invalid value for `region`, must not be `None`")  # noqa: E501

        self._region = region

    @property
    def username(self):
        """Gets the username of this CreateObjectStorageDestination.  # noqa: E501

        Access Key ID for Remote Object Storage Endpoint  # noqa: E501

        :return: The username of this CreateObjectStorageDestination.  # noqa: E501
        :rtype: str
        """
        return self._username

    @username.setter
    def username(self, username):
        """Sets the username of this CreateObjectStorageDestination.

        Access Key ID for Remote Object Storage Endpoint  # noqa: E501

        :param username: The username of this CreateObjectStorageDestination.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and username is None:
            raise ValueError("Invalid value for `username`, must not be `None`")  # noqa: E501

        self._username = username

    @property
    def password(self):
        """Gets the password of this CreateObjectStorageDestination.  # noqa: E501

        Secret Access Key for Remote Object Storage Endpoint  # noqa: E501

        :return: The password of this CreateObjectStorageDestination.  # noqa: E501
        :rtype: str
        """
        return self._password

    @password.setter
    def password(self, password):
        """Sets the password of this CreateObjectStorageDestination.

        Secret Access Key for Remote Object Storage Endpoint  # noqa: E501

        :param password: The password of this CreateObjectStorageDestination.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and password is None:
            raise ValueError("Invalid value for `password`, must not be `None`")  # noqa: E501

        self._password = password

    @property
    def connect_via(self):
        """Gets the connect_via of this CreateObjectStorageDestination.  # noqa: E501

        Connection method for remote object storage  # noqa: E501

        :return: The connect_via of this CreateObjectStorageDestination.  # noqa: E501
        :rtype: str
        """
        return self._connect_via

    @connect_via.setter
    def connect_via(self, connect_via):
        """Sets the connect_via of this CreateObjectStorageDestination.

        Connection method for remote object storage  # noqa: E501

        :param connect_via: The connect_via of this CreateObjectStorageDestination.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and connect_via is None:
            raise ValueError("Invalid value for `connect_via`, must not be `None`")  # noqa: E501
        allowed_values = ["fe", "outnet"]  # noqa: E501
        if (self._configuration.client_side_validation and
                connect_via not in allowed_values):
            raise ValueError(
                "Invalid value for `connect_via` ({0}), must be one of {1}"  # noqa: E501
                .format(connect_via, allowed_values)
            )

        self._connect_via = connect_via

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CreateObjectStorageDestination, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CreateObjectStorageDestination):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, CreateObjectStorageDestination):
            return True

        return self.to_dict() != other.to_dict()
