# coding: utf-8

"""
    Zadara VPSA Object Storage REST API

    # Overview  This document outlines the methods available for administrating your VPSA&#174; Object Storage. The API supports form-encoded, JSON, and XML requests, and can return either JSON or XML responses.  ## Usage  The majority of the APIs available require authentication which requires an API token to use. You can retrieve this token through the Users section of your VPSA, or through the API using the \"Return a user's access key\" API in the Users Section below.  ## Authentication Methods  The authentication token can be passed either through the access_key parameter inside of the body of the REST API request, or through the X-Access-Key header. Alternately, you can use the username and password parameters for authentication, but we do not recommend this method for anything other than possibly retrieving an API key.  By default , all operations are allowed only to VPSA Object Storage admin. Some actions are allowed by an account admin and they will be marked on the action's header  ## Timeouts  By default, all operations that don't complete within five seconds will return a message informing you that the action may take some time to complete. When using the API, this can cause some actions, such as adding drives to storage policy, to be undesirably asynchronous. You can specify your own timeout with the timeout parameter, in seconds, and a timeout value of -1 specifies an infinite timeout.  ## Metering API  Metering information can be retrieved using the VPSA Object Storage API for the following components:  - Accounts - Users - Drives - Virtual Controllers - Load Balancer Groups - Storage Policies  Metering information returned by the API is subject to the following constraints:  - 10 seconds interval - 1 hour range - 1 minute interval - 1 day range - 1 hour interval - 30 days range  Values outside the accepted range will be returned as 0.  ## Questions  If you have any questions or need support involving the REST API, please contact for assistance.   # noqa: E501

    OpenAPI spec version: 23.09
    Contact: support@zadarastorage.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from Zios.configuration import Configuration


class InlineResponse20034Response(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'message': 'str',
        'status': 'int',
        'default_ssl_domain': 'str',
        'default_ssl_enddate': 'str',
        'default_ssl_daysremaining': 'str',
        'current_ssl_domain': 'str',
        'current_ssl_enddate': 'str',
        'current_ssl_daysremaining': 'str'
    }

    attribute_map = {
        'message': 'message',
        'status': 'status',
        'default_ssl_domain': 'default_ssl_domain',
        'default_ssl_enddate': 'default_ssl_enddate',
        'default_ssl_daysremaining': 'default_ssl_daysremaining',
        'current_ssl_domain': 'current_ssl_domain',
        'current_ssl_enddate': 'current_ssl_enddate',
        'current_ssl_daysremaining': 'current_ssl_daysremaining'
    }

    def __init__(self, message=None, status=None, default_ssl_domain=None, default_ssl_enddate=None, default_ssl_daysremaining=None, current_ssl_domain=None, current_ssl_enddate=None, current_ssl_daysremaining=None, _configuration=None):  # noqa: E501
        """InlineResponse20034Response - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._message = None
        self._status = None
        self._default_ssl_domain = None
        self._default_ssl_enddate = None
        self._default_ssl_daysremaining = None
        self._current_ssl_domain = None
        self._current_ssl_enddate = None
        self._current_ssl_daysremaining = None
        self.discriminator = None

        if message is not None:
            self.message = message
        if status is not None:
            self.status = status
        if default_ssl_domain is not None:
            self.default_ssl_domain = default_ssl_domain
        if default_ssl_enddate is not None:
            self.default_ssl_enddate = default_ssl_enddate
        if default_ssl_daysremaining is not None:
            self.default_ssl_daysremaining = default_ssl_daysremaining
        if current_ssl_domain is not None:
            self.current_ssl_domain = current_ssl_domain
        if current_ssl_enddate is not None:
            self.current_ssl_enddate = current_ssl_enddate
        if current_ssl_daysremaining is not None:
            self.current_ssl_daysremaining = current_ssl_daysremaining

    @property
    def message(self):
        """Gets the message of this InlineResponse20034Response.  # noqa: E501


        :return: The message of this InlineResponse20034Response.  # noqa: E501
        :rtype: str
        """
        return self._message

    @message.setter
    def message(self, message):
        """Sets the message of this InlineResponse20034Response.


        :param message: The message of this InlineResponse20034Response.  # noqa: E501
        :type: str
        """

        self._message = message

    @property
    def status(self):
        """Gets the status of this InlineResponse20034Response.  # noqa: E501


        :return: The status of this InlineResponse20034Response.  # noqa: E501
        :rtype: int
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this InlineResponse20034Response.


        :param status: The status of this InlineResponse20034Response.  # noqa: E501
        :type: int
        """

        self._status = status

    @property
    def default_ssl_domain(self):
        """Gets the default_ssl_domain of this InlineResponse20034Response.  # noqa: E501


        :return: The default_ssl_domain of this InlineResponse20034Response.  # noqa: E501
        :rtype: str
        """
        return self._default_ssl_domain

    @default_ssl_domain.setter
    def default_ssl_domain(self, default_ssl_domain):
        """Sets the default_ssl_domain of this InlineResponse20034Response.


        :param default_ssl_domain: The default_ssl_domain of this InlineResponse20034Response.  # noqa: E501
        :type: str
        """

        self._default_ssl_domain = default_ssl_domain

    @property
    def default_ssl_enddate(self):
        """Gets the default_ssl_enddate of this InlineResponse20034Response.  # noqa: E501


        :return: The default_ssl_enddate of this InlineResponse20034Response.  # noqa: E501
        :rtype: str
        """
        return self._default_ssl_enddate

    @default_ssl_enddate.setter
    def default_ssl_enddate(self, default_ssl_enddate):
        """Sets the default_ssl_enddate of this InlineResponse20034Response.


        :param default_ssl_enddate: The default_ssl_enddate of this InlineResponse20034Response.  # noqa: E501
        :type: str
        """

        self._default_ssl_enddate = default_ssl_enddate

    @property
    def default_ssl_daysremaining(self):
        """Gets the default_ssl_daysremaining of this InlineResponse20034Response.  # noqa: E501


        :return: The default_ssl_daysremaining of this InlineResponse20034Response.  # noqa: E501
        :rtype: str
        """
        return self._default_ssl_daysremaining

    @default_ssl_daysremaining.setter
    def default_ssl_daysremaining(self, default_ssl_daysremaining):
        """Sets the default_ssl_daysremaining of this InlineResponse20034Response.


        :param default_ssl_daysremaining: The default_ssl_daysremaining of this InlineResponse20034Response.  # noqa: E501
        :type: str
        """

        self._default_ssl_daysremaining = default_ssl_daysremaining

    @property
    def current_ssl_domain(self):
        """Gets the current_ssl_domain of this InlineResponse20034Response.  # noqa: E501


        :return: The current_ssl_domain of this InlineResponse20034Response.  # noqa: E501
        :rtype: str
        """
        return self._current_ssl_domain

    @current_ssl_domain.setter
    def current_ssl_domain(self, current_ssl_domain):
        """Sets the current_ssl_domain of this InlineResponse20034Response.


        :param current_ssl_domain: The current_ssl_domain of this InlineResponse20034Response.  # noqa: E501
        :type: str
        """

        self._current_ssl_domain = current_ssl_domain

    @property
    def current_ssl_enddate(self):
        """Gets the current_ssl_enddate of this InlineResponse20034Response.  # noqa: E501


        :return: The current_ssl_enddate of this InlineResponse20034Response.  # noqa: E501
        :rtype: str
        """
        return self._current_ssl_enddate

    @current_ssl_enddate.setter
    def current_ssl_enddate(self, current_ssl_enddate):
        """Sets the current_ssl_enddate of this InlineResponse20034Response.


        :param current_ssl_enddate: The current_ssl_enddate of this InlineResponse20034Response.  # noqa: E501
        :type: str
        """

        self._current_ssl_enddate = current_ssl_enddate

    @property
    def current_ssl_daysremaining(self):
        """Gets the current_ssl_daysremaining of this InlineResponse20034Response.  # noqa: E501


        :return: The current_ssl_daysremaining of this InlineResponse20034Response.  # noqa: E501
        :rtype: str
        """
        return self._current_ssl_daysremaining

    @current_ssl_daysremaining.setter
    def current_ssl_daysremaining(self, current_ssl_daysremaining):
        """Sets the current_ssl_daysremaining of this InlineResponse20034Response.


        :param current_ssl_daysremaining: The current_ssl_daysremaining of this InlineResponse20034Response.  # noqa: E501
        :type: str
        """

        self._current_ssl_daysremaining = current_ssl_daysremaining

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(InlineResponse20034Response, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, InlineResponse20034Response):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, InlineResponse20034Response):
            return True

        return self.to_dict() != other.to_dict()
